package crypter

import (
	"testing"
)

func Test_Sm2EncryptWithHexKey(t *testing.T) {
	publicKeyStr := "MFkwEwYHKoZIzj0CAQYIKoEcz1UBgi0DQgAEW8Jjr6PAAbt4CNLwy96IAFYqYzTYNXmFRP5WQIQHlVOyKwGt4mWvOp3cYIYLNPz4Zul+ssHGj6iIR5/g7/GPVQ=="
	message := "Hello, SM2!"
	// ret, err := Sm2Encrypt(message, publicKeyStr)
	// //BB06ddYi5lZ375jb1SWVZz7TrohrDS2XBDxgbMSgK4/oltdKt7tZZ917uZ1BInmrjDhuYpgCXZ9Pm7MACv8jKBT2BeRYEa2bEoh5s9iu0pLkiEbCxEd0+rSQ7QzOTXjOuUMfv05abYImjg==
	// t.Log(ret)
	// t.Log(err)
	publicKeyStr = "042CC19B64E0BD66F39636FD088CDB95B94FC0D6E8F859D6A3CE667EBEF27BAF0DC56EA45C8F48A9C820DB00D84445CF408A533986C2A26AF2A92C22C784A6F63E"
	ret, err := Sm2EncryptWithHexKey(message, publicKeyStr)
	t.Log(ret)
	t.Log(err)

}

func Test_Sm2DecryptWithHexKey(t *testing.T) {
	var private_key string = "MIGTAgEAMBMGByqGSM49AgEGCCqBHM9VAYItBHkwdwIBAQQgeCC1xjOtVEUPXf/sHWGamWnpV2GCJcFXDMNdjHoFXYegCgYIKoEcz1UBgi2hRANCAARbwmOvo8ABu3gI0vDL3ogAVipjNNg1eYVE/lZAhAeVU7IrAa3iZa86ndxghgs0/Phm6X6ywcaPqIhHn+Dv8Y9V"

	// message := "BNw3kw95aBovbvkJQ5NgIQnfDP1xJwGHUii4LWTjmrxzE7zlXkh0Py8+K8XuMFnqJn+9n5VheFyCAwOPg1Iw4yB4CDyBW5hGOXDlXV0qe+iaSdRCFJYoz810HStXKKwRjHA1+L5FXHIU+Q=="
	message := "04b45733bf34c3e11a52027e8f477ce107e3c5ce18e678583b849a05ac98d3bf50997e36539edf9e959a2b2aa3813037ce06da99fc13c5fc60741fce0a056af65abcfc0a3b1fc0969dcb29c8d609076a118fa72c8704f02c47faae45a5eea9dfa99e4e0a83a4954aa2eee089"

	private_key = "4B906B75EB9979A1F2AB00AFC192F2E574451871A003D46B328F88D3EF487836"
	ret, err := Sm2DecryptWithHexKey(message, private_key)
	t.Log(ret)
	t.Log(err)
}

func Test_CreateHexKey(t *testing.T) {
	priv, pub, err := CreateHexKey()
	t.Log(priv)
	t.Log(pub)
	t.Log(err)
}
